package com.blogspot.revbingo.threed;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;

import javax.swing.JPanel;

/*
 * A panel that will display our 3D scene
 */
public class ThreeDeePanel extends JPanel {

	ArrayList<SceneObject> scene = null;  //holds the list of all objects to be drawn
	
	public void setScene(ArrayList<SceneObject> s){
		scene = s;
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);	//standard stuff
	
		if(scene == null) return;  //don't try and draw stuff if it's not ready yet
		Graphics2D g2 = (Graphics2D) g;
		g2.setColor(Color.WHITE);	//we'll draw everything in white to start
		
		//Set the AffineTransformation - this means that the coordinates (0,0) will display
		//in the middle, not the top left.
		g2.translate(this.getWidth()/2, this.getHeight()/2);
		for(SceneObject object : scene){
			object.draw(g2);
		}
	}

	
}
