package com.blogspot.revbingo.threed;

import java.awt.Color;
import java.awt.Graphics2D;

public class Triangle implements SceneObject {

	double[] x = new double[3];
	double[] y = new double[3];
	double[] z = new double[3];
	private int[] xPoints = new int[3];
	private int[] yPoints = new int[3];
	
	public Triangle(double p1x, double p1y, double p1z,
			double p2x, double p2y, double p2z,
			double p3x, double p3y, double p3z) {
		x[0] = p1x;
		x[1] = p2x;
		x[2] = p3x;
		 
		y[0] = p1y;
		y[1] = p2y;
		y[2] = p3y;
		
		z[0] = p1z;
		z[1] = p2z;
		z[2] = p3z;
	}
	
	public void draw(Graphics2D graphics) {
		for(int i = 0; i < 3; i++) {
			xPoints[i] = (int) x[i];
			yPoints[i] = (int) y[i];
		}
		
		graphics.setColor(Color.WHITE);
		graphics.drawPolygon(xPoints, yPoints, 3);
		
	}
	
	public void rotateZ(double radians) {
		double[] sx = x.clone();
		for(int i = 0; i < 3; i++) {
			x[i] = (sx[i] * Math.cos(radians)) - (y[i] * Math.sin(radians));
			y[i] = (y[i] * Math.cos(radians)) + (sx[i] * Math.sin(radians));
		}
	}

	@Override
	public void rotateX(double radians) {
		double[] sy = y.clone();
		for(int i = 0; i < 3; i++) {
			y[i] = (sy[i] * Math.cos(radians)) - (z[i] * Math.sin(radians));
			z[i] = (z[i] * Math.cos(radians)) + (sy[i] * Math.sin(radians));
		}
	}

	@Override
	public void rotateY(double radians) {
		double[] sz = z.clone();
		for(int i = 0; i < 3; i++) {
			z[i] = (sz[i] * Math.cos(radians)) - (x[i] * Math.sin(radians));
			x[i] = (x[i] * Math.cos(radians)) + (sz[i] * Math.sin(radians));
		}	
	}
}
